//Ghammer.cs
datablock AudioProfile(GhammerHitSound)
{
   filename    = "./godHit.wav";
   description = AudioClosest3d;
   preload = true;
};
//effects
if(!isObject(smallBloodParticle))
{
	datablock ParticleData(smallBloodParticle)
	{
	   dragCoefficient = 3;
	   gravityCoefficient = 0.5;
	   inheritedVelFactor = 0.3;
	   constantAcceleration = 0;
	   lifetimeMS         = 1000;
	   lifetimeVarianceMS = 250;
	   textureName = "base/data/particles/ring";
	   spinSpeed     = 0;
	   spinRandomMin = -20;
	   spinRandomMax = 20;
	   colors[0] = "0 0 2 1";
	   colors[1] = "0 0 2 1 ";
	   colors[2] = "0 0 1 0";
	   sizes[0] = 0.06;
	   sizes[1] = 0.09;
	   sizes[2] = 0.04;
	   times[1] = 0.5;
	   times[2] = 1;
	   useInvAlpha = true;
	};
}
if(!isObject(smallBloodEmitter))
{
	datablock ParticleEmitterData(smallBloodEmitter)
	{
	   ejectionPeriodMS = 2;
	   periodVarianceMS = 0;
	   ejectionVelocity = 2;
	   velocityVariance = 1.2;
	   ejectionOffset   = 0;
	   thetaMin = 0;
	   thetaMax = 180;
	   phiReferenceVel = 0;
	   phiVariance     = 360;
	   overrideAdvance = false;
	   lifetimeMS = 3500;
	   particles = "smallBloodParticle";

	   uiName = "Ancient Blood";
	};
}
datablock ExplosionData(GhammerBleedExplosion : deathExplosion)
{
	soundProfile = "";
	particleEmitter = smallBloodEmitter;
	particleDensity = 40;
	particleRadius = 0.1;
	emitter[0] = smallBloodEmitter;
	emitter[1] = smallBloodEmitter;
	emitter[2] = smallBloodEmitter;
	lifetimeMS = 250;
	offset = 0.5;
	lightStartRadius = 0;
	lightEndRadius = 0;
};
datablock ProjectileData(GhammerBleedProjectile : deathProjectile)
{
	explosion = GhammerBleedExplosion;
};
datablock ParticleData(GhammerExplosionParticle)
{
   dragCoefficient      = 2;
   gravityCoefficient   = 1.0;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;
   spinRandomMin = -90;
   spinRandomMax = 90;
   lifetimeMS           = 500;
   lifetimeVarianceMS   = 300;
   textureName          = "base/data/particles/ring";
   colors[0]     = "0 0 1 0";
   colors[1]     = "0 0 1 0";
   sizes[0]      = 0.5;
   sizes[1]      = 0.25;
};

datablock ParticleEmitterData(GhammerExplosionEmitter)
{
   ejectionPeriodMS = 7;
   periodVarianceMS = 0;
   ejectionVelocity = 8;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 60;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "GhammerExplosionParticle";

   uiName = "Goddess Hammer Hit";
};

datablock ExplosionData(GhammerExplosion)
{
   //explosionShape = "";
   lifeTimeMS = 500;

   soundProfile = GhammerHitSound;

   particleEmitter = GhammerExplosionEmitter;
   particleDensity = 10;
   particleRadius = 0.2;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "20.0 22.0 20.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 3;
   lightEndRadius = 0;
   lightStartColor = "00.0 0.2 0.6";
   lightEndColor = "0 0 0";
};


//projectile
AddDamageType("Ghammer",   '<bitmap:add-ons/Weapon_GoddessHammer/CI_GHammer> %1',    '%2 <bitmap:add-ons/Weapon_GoddessHammer/CI_GHammer> %1',0.75,1);
datablock ProjectileData(GhammerProjectile)
{
   directDamage        = 300000;
   directDamageType  = $DamageType::Ghammer;
   radiusDamageType  = $DamageType::Ghammer;
   explosion           = GhammerExplosion;
   //particleEmitter     = as;

   muzzleVelocity      = 50;
   velInheritFactor    = 1;

   armingDelay         = 0;
   lifetime            = 100;
   fadeDelay           = 70;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";

   uiName = "Goddess Hammer Slice";
};


//////////
// item //
//////////
datablock ItemData(GhammerItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./god.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Goddess Hammer";
	iconName = "./icon_GHammer";
	doColorShift = true;
	colorShiftColor = "0.471 0.471 0.471 1.000";

	 // Dynamic properties defined by the scripts
	image = GhammerImage;
	canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(GhammerImage)
{
   // Basic Item properties
   shapeFile = "./god.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = false;

   eyeOffset = "0 0 0";

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = GhammerItem;
   ammo = " ";
   projectile = GhammerProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = true;
   doRetraction = false;
   //raise your arm up or not
   armReady = true;

   //casing = " ";
   doColorShift = false;
   colorShiftColor = "0.471 0.471 0.471 1.000";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 1.0;
	stateTransitionOnTimeout[0]      = "Ready";
	stateSound[0]                    = weaponSwitchSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "PreFire";
	stateAllowImageChange[1]         = true;

	stateName[2]			= "PreFire";
	stateScript[2]                  = "onPreFire";
	stateAllowImageChange[2]        = false;
	stateTimeoutValue[2]            = 0.1;
	stateTransitionOnTimeout[2]     = "Fire";

	stateName[3]                    = "Fire";
	stateTransitionOnTimeout[3]     = "WaitFire";
	stateTimeoutValue[3]            = 0.2;
	stateFire[3]                    = true;
	stateAllowImageChange[3]        = false;
	stateSequence[3]                = "Fire";
	stateScript[3]                  = "onFire";
	stateWaitForTimeout[3]		= true;

	stateName[4]			= "CheckFire";
	stateTransitionOnTriggerUp[4]	= "StopFire";
	stateTransitionOnTriggerDown[4]	= "PreFire";
	
	stateName[6] 					= "WaitFire";
	stateScript[6]                  = "onWaitFire";
	stateTimeoutValue[6]			= 1.0;
	stateTransitionOnTriggerUp[6]	= "StopFire";
	stateTransitionOnTimeout[6]     = "CheckFire";
	stateWaitForTimeout[6]		= true;
	
	stateName[5]                    = "StopFire";
	stateTransitionOnTimeout[5]     = "Ready";
	stateTimeoutValue[5]            = 0.2;
	stateAllowImageChange[5]        = false;
	stateWaitForTimeout[5]		= true;
	stateSequence[5]                = "StopFire";
	stateScript[5]                  = "onStopFire";


};

function GhammerImage::onPreFire(%this, %obj, %slot)
{
	%obj.playthread(2, armattack);
}

function GhammerImage::onStopFire(%this, %obj, %slot)
{	
	%obj.playthread(2, root);
}
function GhammerImage::onWaitFire(%this, %obj, %slot)
{	
	%obj.playthread(2, root);
}
function GhammerProjectile::onCollision(%this, %obj, %col, %vec, %vecLen)
{
	parent::onCollision(%this, %obj, %col, %vec, %vecLen);
	if(%col.getClassName() $= "player" || %col.getClassName() $= "aiPlayer")
	{
		if(minigameCanDamage(%col,%obj))
		{
			%col.swol_GhammerBleedStart(5,10,750,%obj.sourceObject.client);
		}
	}
}
function player::swol_GhammerBleedStart(%this,%amt,%dmg,%delay,%atk)
{
	%this.GhammerBleedSched = %this.schedule(5,swol_GhammerBleedLoop,%amt,%dmg,%delay,%atk);
}
function player::swol_GhammerBleedLoop(%this,%amt,%dmg,%delay,%atk)
{
	cancel(%this.GhammerBleedSched);
	if(!isObject(%this))
	return;
	if(%this.getState() $= "Dead")
	return;
	if(%amt < 0)
	return;
	
	%amt--;
	
	%this.spawnExplosion(GhammerBleedProjectile,"1.2 1.2 1.2");
	%this.damage(%atk,%this.getPosition(),%dmg,$DamageType::Ghammer);
	%this.GhammerBleedSched = %this.schedule(%delay,swol_GhammerBleedLoop,%amt,%dmg,%delay,%atk);
}